"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs3/helpers/interopRequireWildcard").default;
var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault").default;
exports.__esModule = true;
exports.default = void 0;
var _stampit = _interopRequireDefault(require("stampit"));
var _apidomCore = require("@swagger-api/apidom-core");
var _apidomNsOpenapi = _interopRequireWildcard(require("@swagger-api/apidom-ns-openapi-3-0"));
var _ResolveStrategy = _interopRequireDefault(require("../ResolveStrategy.cjs"));
var _ReferenceSet = _interopRequireDefault(require("../../../ReferenceSet.cjs"));
var _Reference = _interopRequireDefault(require("../../../Reference.cjs"));
var _visitor = _interopRequireDefault(require("./visitor.cjs"));
// @ts-ignore
const visitAsync = _apidomCore.visit[Symbol.for('nodejs.util.promisify.custom')];

// eslint-disable-next-line @typescript-eslint/naming-convention
const OpenApi3_0ResolveStrategy = (0, _stampit.default)(_ResolveStrategy.default, {
  init() {
    this.name = 'asyncapi-2';
  },
  methods: {
    canResolve(file) {
      var _file$parseResult;
      // assert by media type
      if (file.mediaType !== 'text/plain') {
        return _apidomNsOpenapi.mediaTypes.includes(file.mediaType);
      }

      // assert by inspecting ApiDOM
      return (0, _apidomNsOpenapi.isOpenApi3_0Element)((_file$parseResult = file.parseResult) == null ? void 0 : _file$parseResult.api);
    },
    async resolve(file, options) {
      const namespace = (0, _apidomCore.createNamespace)(_apidomNsOpenapi.default);
      const reference = (0, _Reference.default)({
        uri: file.uri,
        value: file.parseResult
      });
      const visitor = (0, _visitor.default)({
        reference,
        namespace,
        options
      });
      const refSet = (0, _ReferenceSet.default)();
      refSet.add(reference);
      await visitAsync(refSet.rootRef.value, visitor, {
        keyMap: _apidomNsOpenapi.keyMap,
        nodeTypeGetter: _apidomNsOpenapi.getNodeType
      });
      await visitor.crawl();
      return refSet;
    }
  }
});
var _default = exports.default = OpenApi3_0ResolveStrategy;